[LeetCode] 451. Sort Characters By Frequency

linspiration發表於2019-01-19

Problem

Given a string, sort it in decreasing order based on the frequency of characters.

Example 1:

Input:
"tree"

Output:
"eert"

Explanation:
`e` appears twice while `r` and `t` both appear once.
So `e` must appear before both `r` and `t`. Therefore “eetr” is also a valid answer.
Example 2:

Input:
"cccaaa"

Output:
"cccaaa"

Explanation:
Both `c` and `a` appear three times, so “aaaccc” is also a valid answer.
Note that “cacaca” is incorrect, as the same characters must be together.
Example 3:

Input:
"Aabb"

Output:
"bbAa"

Explanation:
“bbaA” is also a valid answer, but “Aabb” is incorrect.
Note that `A` and `a` are treated as two different characters.

Solution

class Solution {
    public String frequencySort(String s) {
        Map<Character, Integer> map = new HashMap<>();
        for (int i = 0; i < s.length(); i++) {
            map.put(s.charAt(i), map.getOrDefault(s.charAt(i), 0)+1);
        }
        
        PriorityQueue<Map.Entry<Character, Integer>> queue = new PriorityQueue<>((a, b)->b.getValue()-a.getValue());
        queue.addAll(map.entrySet());
        
        StringBuilder sb = new StringBuilder();
        while (!queue.isEmpty()) {
            Map.Entry entry = queue.poll();
            for (int i = 0; i < (int)entry.getValue(); i++) sb.append(entry.getKey());
        }
        
        return sb.toString();
    }
}

Bucket Sort

class Solution {
    public String frequencySort(String s) {
        Map<Character, Integer> map = new HashMap<>();
        for (int i = 0; i < s.length(); i++) {
            map.put(s.charAt(i), map.getOrDefault(s.charAt(i), 0)+1);
        }
        
        List<Character>[] buckets = new ArrayList[s.length()+1];
        for (Map.Entry<Character, Integer> entry: map.entrySet()) {
            int i = entry.getValue();
            if (buckets[i] == null) buckets[i] = new ArrayList<>();
            buckets[i].add(entry.getKey());
        }
        StringBuilder sb = new StringBuilder();
        for (int i = s.length(); i >= 0; i--) {
            if (buckets[i] != null && buckets[i].size() > 0) {
                for (Character ch: buckets[i]) {
                    for (int j = i; j > 0; j--) sb.append(ch);
                }
            }
        }
        return sb.toString();
    }
}

相關文章